<!DOCTYPE html>
<meta charset="utf-8">
<style>

.node {
  cursor: pointer;
}

.node:hover {
  stroke: #000;
  stroke-width: 1.5px;
}

.node--leaf {
  fill: white;
}

.label {
  font: 11px "Helvetica Neue", Helvetica, Arial, sans-serif;
  text-anchor: middle;
  text-shadow: 0 1px 0 #fff, 1px 0 0 #fff, -1px 0 0 #fff, 0 -1px 0 #fff;
}

.label,
.node--root,
.node--leaf {
  pointer-events: none;
}

.legend rect {
  fill:white;
  stroke:black;
  opacity:0.8;}

</style>
<svg width="960" height="960"></svg>
<script src="d3.legend.js"></script>
<script src="https://d3js.org/d3.v4.min.js"></script>
<script>

var legendRectSize = 18;
var legendSpacing = 4;


// création du SVG
var svg = d3.select("svg"),
    margin = 20,
    diameter = +svg.attr("width"),
    g = svg.append("g").attr("transform", "translate(" + diameter / 2 + "," + diameter / 2 + ")");

var color = d3.scaleOrdinal(d3.schemeCategory20).domain(d3.range(0, 20));		// échelle de couleurs pour les caractéristiques
var colorPack = d3.scaleOrdinal(d3.schemeCategory20c).domain(d3.range(0, 9));	// échelle de couleurs pour les emboitements


var pack = d3.pack()
    .size([diameter - margin, diameter - margin])
    .padding(2);

d3.json("output.json", function(error, root)
{
	if (error) throw error;

	// rapatriement de la hiérarchie
	root = d3.hierarchy(root)
		.sum(function(d) { return d.size; })
		.sort(function(a, b) { return b.value - a.value; });

	var focus = root,
		nodes = pack(root).descendants(),
		view;

	// propriétés graphiques & interactives des cercles
	var circle = g.selectAll("circle")
		.data(nodes)
		.enter()
			.append("circle")
				.attr("class", function(d) { return d.parent ? d.children ? "node" : "node node--leaf" : "node node--root"; })
				.style("fill", function(d) { return (!d.children ? color(d.data.color) : colorPack(d.depth)); })
				.on("click", function(d) { if (focus !== d) zoom(d), d3.event.stopPropagation(); });

	// propriétés graphiques du texte
	var text = g.selectAll("text")
		.data(nodes)
		.enter()
			.append("text")
			.attr("class", "label")
			.style("fill-opacity", function(d) { return d.parent === root ? 1 : 0; })
			.style("display", function(d) { return d.parent === root ? "inline" : "none"; })
			.text(function(d) { return d.data.name; });

	
	var node = g.selectAll("circle,text");

	// ajout de l'intéraction de zoom sur le SVG
	svg
		.style("background", color(-1))
		.on("click", function() { zoom(root); })
		zoomTo([root.x, root.y, root.r * 2 + margin]);

  
	function zoom(d)
	{
		var focus0 = focus; focus = d;

		var transition = d3.transition()
			.duration(d3.event.altKey ? 7500 : 750)
			.tween("zoom", function(d)
			{
				var i = d3.interpolateZoom(view, [focus.x, focus.y, focus.r * 2 + margin]);
				return function(t) { zoomTo(i(t)); };
			});

		transition.selectAll("text")
			.filter(function(d) { return d.parent === focus || this.style.display === "inline"; })
			.style("fill-opacity", function(d) { return d.parent === focus ? 1 : 0; })
			.on("start", function(d) { if (d.parent === focus) this.style.display = "inline"; })
			.on("end", function(d) { if (d.parent !== focus) this.style.display = "none"; });
	}

	function zoomTo(v)
	{
		var k = diameter / v[2]; view = v;
		node.attr("transform", function(d) { return "translate(" + (d.x - v[0]) * k + "," + (d.y - v[1]) * k + ")"; });
		circle.attr("r", function(d) { return d.r * k; });
	}
  
 	// ajout de la légende sur les caractéristiques
	d3.json("output_legend.json", function (error,data,col)
	{

		function tabulate(data, columns) 
		{
			var table = d3.select('body').append('table')
			var thead = table.append('thead')
			var	tbody = table.append('tbody');

			// append the header row
			thead.append('tr')
		  		.selectAll('th')
		  		.data(columns).enter()
		  		.append('th')
		    	.text( function (column) { return column; });

			// create a row for each object in the data
			var rows = tbody.selectAll('tr')
				.data(data)
				.enter()	
				.append('tr')
				.style("background-color", function(d){ return color(d.color);});	
    			
			// create a cell in each row for each column
			var cells = rows.selectAll('td')
		  		.data(function (row) 
				{
		    		return columns.map
					(
						function (column) 
						{
		      				return {column: column, value: row[column]};
		    			}
					);
				})
				.enter()
				.append('td')
					.text(function (d) { return d.value ; });
				
			return table;
		}
	
	// render the table(s)
	var tab = tabulate(data, ['legend']); // 2 column table
	
	// ajout de la légende sur les seuils
	d3.json("output_legend_thrs.json", function (error,data,col)
	{ 
		function tabulate(data, columns) 
		{
			var table = d3.select('body').append('table')
			var thead = table.append('thead')
			var	tbody = table.append('tbody');

			// append the header row
			thead.append('tr')
		  		.selectAll('th')
		  		.data(columns).enter()
		  		.append('th')
		    	.text( function (column) { return column; });

			// create a row for each object in the data
			var rows = tbody.selectAll('tr')
				.data(data)
				.enter()	
				.append('tr')
				.style("background-color", function(d){ return colorPack (d.color);});	
    			
			// create a cell in each row for each column
			var cells = rows.selectAll('td')
		  		.data(function (row) 
				{
		    		return columns.map
					(
						function (column) 
						{
		      				return {column: column, value: row[column]};
		    			}
					);
				})
				.enter()
				.append('td')
					.text(function (d) { return d.value ; });
				
			return table;
		}
	
		var tab1 = tabulate(data, ['threshold'],'thrs'); // 2 column table
	});
	
    
})
      


});



</script>

